'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaultStyles = {
  container: {},
  value: {},
  order: {}
};

var header = function header(_ref) {
  var sortable = _ref.sortable;
  var getSortingColumns = _ref.getSortingColumns;
  var _ref$styles = _ref.styles;
  var styles = _ref$styles === undefined ? {} : _ref$styles;
  var _ref$fieldName = _ref.fieldName;
  var fieldName = _ref$fieldName === undefined ? 'columnIndex' : _ref$fieldName;

  if (!sortable) {
    throw new Error('header - Missing sortable!');
  }
  if (!getSortingColumns) {
    throw new Error('header - Missing getSortingColumns!');
  }

  var headerStyles = _extends({}, defaultStyles, styles);

  return function (value, extra) {
    var sortingColumns = getSortingColumns();
    var sortingColumn = sortingColumns && sortingColumns[extra[fieldName]] || {};
    var sortingPosition = sortingColumn.position;

    return _react2.default.createElement(
      'div',
      { className: 'sort-container', style: headerStyles.container },
      _react2.default.createElement(
        'span',
        {
          className: 'sort-value',
          style: headerStyles.value
        },
        value
      ),
      {}.hasOwnProperty.call(sortingColumn, 'position') ? _react2.default.createElement(
        'span',
        {
          className: 'sort-order',
          style: headerStyles.order
        },
        sortingPosition + 1
      ) : null,
      _react2.default.createElement('span', sortable(value, extra))
    );
  };
};

exports.default = header;