var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from 'react';

const defaultStyles = {
  container: {},
  value: {},
  order: {}
};

const header = ({
  sortable,
  getSortingColumns,
  styles = {},
  fieldName = 'columnIndex'
}) => {
  if (!sortable) {
    throw new Error('header - Missing sortable!');
  }
  if (!getSortingColumns) {
    throw new Error('header - Missing getSortingColumns!');
  }

  const headerStyles = _extends({}, defaultStyles, styles);

  return (value, extra) => {
    const sortingColumns = getSortingColumns();
    const sortingColumn = sortingColumns && sortingColumns[extra[fieldName]] || {};
    const sortingPosition = sortingColumn.position;

    return React.createElement(
      'div',
      { className: 'sort-container', style: headerStyles.container },
      React.createElement(
        'span',
        {
          className: 'sort-value',
          style: headerStyles.value
        },
        value
      ),
      {}.hasOwnProperty.call(sortingColumn, 'position') ? React.createElement(
        'span',
        {
          className: 'sort-order',
          style: headerStyles.order
        },
        sortingPosition + 1
      ) : null,
      React.createElement('span', sortable(value, extra))
    );
  };
};

export default header;