var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

const reset = ({
  event = 'onDoubleClick',
  getSortingColumns = () => [],
  onReset = () => {},
  fieldName = 'columnIndex'
}) => (value, extra) => ({
  [event]: () => {
    const sortingColumns = getSortingColumns();

    if (!sortingColumns || !Object.keys(sortingColumns).length) {
      return;
    }

    const field = extra[fieldName];

    const position = sortingColumns[field].position;
    const newSortingColumns = {};

    delete sortingColumns[field];

    Object.keys(sortingColumns).forEach(k => {
      const column = sortingColumns[k];

      if (column.position > position) {
        newSortingColumns[k] = _extends({}, column, {
          position: column.position - 1
        });
      } else {
        newSortingColumns[k] = column;
      }
    });

    onReset({
      sortingColumns: newSortingColumns
    });
  }
});

export default reset;