var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import { mergeClassNames } from 'reactabular-utils';

const sort = ({
  event = 'onClick',
  getSortingColumns = () => [],
  onSort = () => {},
  fieldName = 'columnIndex'
} = {}) => (_value, extra, { className, ...props } = {}) => {
  const sortingColumns = getSortingColumns();
  const field = extra[fieldName];
  let headerClass = 'sort sort-none';

  // Check against undefined to allow zero
  if (sortingColumns[field] !== undefined) {
    headerClass = `sort sort-${ sortingColumns[field].direction }`;
  }

  return _extends({}, props, {
    className: mergeClassNames(className, headerClass),
    [event]: () => onSort(field)
  });
};

export default sort;